<html>
<head>
<title>OgreD3D11HardwareBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a2df88393729a3f182c00116937c948.html">Direct3D11</a>      </li>
      <li class="navelem"><a class="el" href="dir_80c990f15d364d52e4690b415f060ae9.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D11HardwareBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D11HardwareBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D11HARDWAREBUFFER_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D11HARDWAREBUFFER_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Prerequisites_8h.html">OgreD3D11Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareBuffer_8h.html">OgreHardwareBuffer.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre { 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00040"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html">00040</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html" title="Base implementation of a D3D11 buffer, dealing with all the common aspects.">D3D11HardwareBuffer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>
<a name="l00041"></a>00041     {
<a name="l00042"></a>00042     <span class="keyword">public</span>:
<a name="l00043"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a8cb71d471b5b775fcfd20d34b3dc82fa">00043</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a8cb71d471b5b775fcfd20d34b3dc82fa">BufferType</a>
<a name="l00044"></a>00044         {
<a name="l00045"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a8cb71d471b5b775fcfd20d34b3dc82faa0547822d009e03285a26870a6adb8899">00045</a>             <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a8cb71d471b5b775fcfd20d34b3dc82faa0547822d009e03285a26870a6adb8899">VERTEX_BUFFER</a>,
<a name="l00046"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a8cb71d471b5b775fcfd20d34b3dc82faa3d0f7113565d33b22f25039dde7fe4a3">00046</a>             <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a8cb71d471b5b775fcfd20d34b3dc82faa3d0f7113565d33b22f25039dde7fe4a3">INDEX_BUFFER</a>
<a name="l00047"></a>00047         };
<a name="l00048"></a>00048     <span class="keyword">protected</span>:
<a name="l00049"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a4b888255539cdad87b5ba67df03f05d2">00049</a>         ID3D11Buffer* <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a4b888255539cdad87b5ba67df03f05d2">mlpD3DBuffer</a>;
<a name="l00050"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#af47a21cd6d6a61fa84cd5f9b39bc6b38">00050</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#af47a21cd6d6a61fa84cd5f9b39bc6b38">mUseTempStagingBuffer</a>;
<a name="l00051"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a840cddf062b3c145ba9ae836cc7ae6b9">00051</a>         <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html" title="Base implementation of a D3D11 buffer, dealing with all the common aspects.">D3D11HardwareBuffer</a>* <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a840cddf062b3c145ba9ae836cc7ae6b9">mpTempStagingBuffer</a>;
<a name="l00052"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a2f39c6ce6fd2f81f77a8e2d3fa121530">00052</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a2f39c6ce6fd2f81f77a8e2d3fa121530">mStagingUploadNeeded</a>;
<a name="l00053"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a4633c75f86a578eb099ba8f5f29adb1c">00053</a>         <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a8cb71d471b5b775fcfd20d34b3dc82fa">BufferType</a> <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a4633c75f86a578eb099ba8f5f29adb1c">mBufferType</a>;
<a name="l00054"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a3a156af2b7e1cda7c85707b0bb067236">00054</a>         <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a3a156af2b7e1cda7c85707b0bb067236">mDevice</a>;
<a name="l00055"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a2e817edb62b3a17e9118d4867571b512">00055</a>         D3D11_BUFFER_DESC <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a2e817edb62b3a17e9118d4867571b512">mDesc</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00060"></a>00060         <span class="keywordtype">void</span>* <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a6e8254b9b6de0480ced5c3dc335f8494" title="See HardwareBuffer.">lockImpl</a>(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00062"></a>00062         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#aeb33d416451e001de7aae037f6be80ff" title="See HardwareBuffer.">unlockImpl</a>(<span class="keywordtype">void</span>);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keyword">public</span>:
<a name="l00065"></a>00065         <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#aa0dbd8ff846bb8a4eee5cb3c740b9c3b">D3D11HardwareBuffer</a>(<a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a8cb71d471b5b775fcfd20d34b3dc82fa">BufferType</a> btype, <span class="keywordtype">size_t</span> sizeBytes, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, 
<a name="l00066"></a>00066             <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device, <span class="keywordtype">bool</span> useSystemMem, <span class="keywordtype">bool</span> useShadowBuffer, <span class="keywordtype">bool</span> streamOut);
<a name="l00067"></a>00067         <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a96f989e769ef9aadcb7e9ef94a1b084a">~D3D11HardwareBuffer</a>();
<a name="l00069"></a>00069         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a453360bd8cd047709eb102741d0349b2" title="See HardwareBuffer.">readData</a>(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">void</span>* pDest);
<a name="l00071"></a>00071         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a68bc8ad6abbe97fc9ea5d30fcd8aa644" title="See HardwareBuffer.">writeData</a>(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keyword">const</span> <span class="keywordtype">void</span>* pSource,
<a name="l00072"></a>00072             <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>);
<a name="l00074"></a>00074         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a09a5a1ce569c36ad6b180b9cb3ebb67d" title="See HardwareBuffer.">copyData</a>(<a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>&amp; srcBuffer, <span class="keywordtype">size_t</span> srcOffset, 
<a name="l00075"></a>00075             <span class="keywordtype">size_t</span> dstOffset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>);
<a name="l00076"></a>00076 
<a name="l00078"></a><a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#ae00b006ed12125f56ed98b932cdfb2f8">00078</a>         ID3D11Buffer* <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#ae00b006ed12125f56ed98b932cdfb2f8" title="Get the D3D-specific buffer.">getD3DBuffer</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11HardwareBuffer.html#a4b888255539cdad87b5ba67df03f05d2">mlpD3DBuffer</a>; }
<a name="l00079"></a>00079     };
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="preprocessor">#endif</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
